//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "direct.h"
#include "stdio.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------



void __fastcall TMainForm::btnDemo1Click(TObject *Sender)
{
	long id;
	char sOutFname[_MAX_PATH];
        char sOwnerPw[] = "user";
	char sUserPw[]  = "owner";
	int xDPI=300;
	int yDPI=300;

	if( Load() ){
		if( id = oakBegin() ){

			//=============================================================
			//set output file
			strcpy(sOutFname, "output.pdf");
			oakSetOption(id, OAK_Set_Output, 0, 0, sOutFname, NULL);

			//set image DPI ,default xdpi=150,ydpi=150
			oakSetOption(id, OAK_Set_DPI, xDPI, yDPI, NULL, NULL);

			//set pdf info
			oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFInfo_TITLE, "title");
			oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFInfo_SUBJECT, "subject");
			oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFINfo_AUTHOR, "author");
			oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFINfo_KEYWORDS, "keywords");
			oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFInfo_APPLICATION, "creator");
	
			//set pdf security
			oakSetOption(id, OAK_Set_PDFEncrypt, OAK_PDF_ENCRYPT_LEVEL_128, OAK_PDF_PERMISSION_NONE, NULL, sOwnerPw);
			//oakSetOption(id, OAK_Set_PDFEncrypt, OAK_PDF_ENCRYPT_LEVEL_40, OAK_PDF_PERMISSION_PRINT, sUserPw, sOwnerPw);

			//set input file
			oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test1.pcl", NULL);
			oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test2.pcl", NULL);
			oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test3.pcl", NULL);

			
			//strat convert
			long lret = oakExport(id);

			oakEnd(id);
		}


		Free();
	}else{
		MessageBox(NULL,"Loading pcltotiff.dll failure!", "demo", MB_OK);
	}
}

//---------------------------------------------------------------------------

//---------------------------------------------------------------------------



BOOL TMainForm::Load(){
	char szDLL[] = "pcltopdf.dll";

	hmodule=LoadLibrary(szDLL);
	if(hmodule==NULL)
		goto Failer;

	oakBegin=(poakBegin)GetProcAddress(hmodule,"_oakBegin@0");
	if(oakBegin==NULL)
		goto Failer;
	oakEnd=(poakEnd)GetProcAddress(hmodule,"_oakEnd@4");
	if(oakEnd==NULL)
		goto Failer;
	oakExport=(poakExport)GetProcAddress(hmodule,"_oakExport@4");
	if(oakExport==NULL)
		goto Failer;
	oakSetOption=(poakSetOption)GetProcAddress(hmodule,"_oakSetOption@24");
	if(oakSetOption==NULL)
		goto Failer;
	oakGetOption=(poakGetOption)GetProcAddress(hmodule,"_oakGetOption@24");
	if(oakGetOption==NULL)
		goto Failer;
	return TRUE;

Failer:
	Free(); 
	return FALSE;
}


void TMainForm::Free(){
	if(hmodule==NULL)
        return;
	FreeLibrary(hmodule);
	hmodule=NULL;
}

