// demo_vcDlg.cpp : implementation file
//

#include "stdafx.h"
#include "demo_vc.h"
#include "demo_vcDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemo_vcDlg dialog

CDemo_vcDlg::CDemo_vcDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemo_vcDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemo_vcDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemo_vcDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemo_vcDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemo_vcDlg, CDialog)
	//{{AFX_MSG_MAP(CDemo_vcDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_DEMO, OnButtonDemo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemo_vcDlg message handlers

BOOL CDemo_vcDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDemo_vcDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDemo_vcDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDemo_vcDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}





//==============================================================================================================

BOOL CDemo_vcDlg::Load()
{
	char szDLL[] = "pcltopdf.dll";

	hmodule=LoadLibrary(szDLL);
	if(hmodule==NULL)
		goto Failer;

	oakBegin=(poakBegin)GetProcAddress(hmodule,"_oakBegin@0");
	if(oakBegin==NULL)
		goto Failer;
	oakEnd=(poakEnd)GetProcAddress(hmodule,"_oakEnd@4");
	if(oakEnd==NULL)
		goto Failer;
	oakExport=(poakExport)GetProcAddress(hmodule,"_oakExport@4");
	if(oakExport==NULL)
		goto Failer;
	oakSetOption=(poakSetOption)GetProcAddress(hmodule,"_oakSetOption@24");
	if(oakSetOption==NULL)
		goto Failer;
	oakGetOption=(poakGetOption)GetProcAddress(hmodule,"_oakGetOption@24");
	if(oakGetOption==NULL)
		goto Failer;
	return TRUE;

Failer:
	Free(); 
	return FALSE;
}
//==============================================================================================================

void CDemo_vcDlg::Free()
{
	if(hmodule==NULL) return;
	FreeLibrary(hmodule);
	hmodule=NULL;
}



//Convert appointed PCL files to a multipage tiff.
//==============================================================================================================
void CDemo_vcDlg::OnButtonDemo() 
{
	// TODO: Add your control notification handler code here
	long id;
	char sOutFname[_MAX_PATH];
    char sOwnerPw[] = "user";
	char sUserPw[]  = "owner";
	int xdpi=300;
	int ydpi=300;

	if( Load() ){
		if( id = oakBegin() ){

			//=============================================================
			//set output file
			strcpy(sOutFname, "output.pdf");
			oakSetOption(id, OAK_Set_Output, 0, 0, sOutFname, NULL);

			//set image DPI ,default xdpi=150,ydpi=150
			oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, NULL, NULL);

			//set pdf info
			oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFInfo_TITLE, "title");
			oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFInfo_SUBJECT, "subject");
			oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFINfo_AUTHOR, "author");
			oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFINfo_KEYWORDS, "keywords");
			oakSetOption(id, OAK_Set_PDFInfo, 0, 0, OAK_PDFInfo_APPLICATION, "creator");
	
			//set pdf security
			oakSetOption(id, OAK_Set_PDFEncrypt, OAK_PDF_ENCRYPT_LEVEL_128, OAK_PDF_PERMISSION_NONE, NULL, sOwnerPw);
			//oakSetOption(id, OAK_Set_PDFEncrypt, OAK_PDF_ENCRYPT_LEVEL_40, OAK_PDF_PERMISSION_PRINT, sUserPw, sOwnerPw);

			//set input file
			oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test1.pcl", NULL);
			oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test2.pcl", NULL);
			oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test3.pcl", NULL);

			
			//strat convert
			long lret = oakExport(id);

			oakEnd(id);
		}

		Free();
	}else{
		MessageBox("Loading dll failure!", "demo", MB_OK);
	}
}
//==============================================================================================================
