//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>



//Interface definitions.
//==============================================================================================================
typedef long	(__stdcall *poakBegin)();
typedef void	(__stdcall *poakEnd)(long id);
typedef long	(__stdcall *poakExport)(long id);
typedef long	(__stdcall *poakSetOption)(long id,long code,long nPara1,long nPara2,char *pPara1,char *pPara2);
typedef long	(__stdcall *poakGetOption)(long id,long code,long nPara1,long nPara2,char *pPara1,char *pPara2);


//Definitions of oakSetOption's nIndex properties 
//==============================================================================================================
#define OAK_Set_Output		2101
#define OAK_Set_Input		2102
#define OAK_Set_DPI			2103
#define OAK_Set_PDFInfo		2105
#define OAK_Set_PDFEncrypt	2106

//Supported pdf information
#define OAK_PDFInfo_TITLE          "title"
#define OAK_PDFInfo_SUBJECT        "subject"
#define OAK_PDFINfo_AUTHOR         "author"
#define OAK_PDFINfo_KEYWORDS       "keywords"
#define OAK_PDFInfo_APPLICATION    "creator"

//Supported the length of pdf encrypt
#define OAK_PDF_ENCRYPT_LEVEL_40   40
#define OAK_PDF_ENCRYPT_LEVEL_128  128

//Supported operation limited
#define OAK_PDF_PERMISSION_NONE     0
#define OAK_PDF_PERMISSION_PRINT    1
#define OAK_PDF_PERMISSION_COPYING  2
#define OAK_PDF_PERMISSION_MODIFY   4
#define OAK_PDF_PERMISSION_ALL      7





//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
        TButton *btnDemo1;
        TProgressBar *m_ProgressBar;
        void __fastcall btnDemo1Click(TObject *Sender);
       
private:	// User declarations
//SDK interface definitions.
//---------------------------------------------------------------------------
	HMODULE hmodule;
	poakBegin oakBegin;
	poakEnd oakEnd;
	poakExport oakExport;
	poakSetOption oakSetOption;
	poakGetOption oakGetOption;

	BOOL Load();  //Load dynamic link library "pdf2image.dll"!
	void Free();  //free dynamic link library "pdf2image.dll"!
//----------------------------------------------------------------------------

public:		// User declarations
        __fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
