// demo_vcDlg.h : header file
//

#if !defined(AFX_DEMO_VCDLG_H__B3EC57B5_DD17_41B3_BB1F_E1493109F05D__INCLUDED_)
#define AFX_DEMO_VCDLG_H__B3EC57B5_DD17_41B3_BB1F_E1493109F05D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CDemo_vcDlg dialog


//Definitions of oakSetOption's nIndex properties 
//==============================================================================================================
#define OAK_Set_Output		2101
#define OAK_Set_Input		2102
#define OAK_Set_DPI			2103
#define OAK_Set_PDFInfo		2105
#define OAK_Set_PDFEncrypt	2106

//Supported pdf information
#define OAK_PDFInfo_TITLE          "title"
#define OAK_PDFInfo_SUBJECT        "subject"
#define OAK_PDFINfo_AUTHOR         "author"
#define OAK_PDFINfo_KEYWORDS       "keywords"
#define OAK_PDFInfo_APPLICATION    "creator"

//Supported the length of pdf encrypt
#define OAK_PDF_ENCRYPT_LEVEL_40   40
#define OAK_PDF_ENCRYPT_LEVEL_128  128

//Supported operation limited
#define OAK_PDF_PERMISSION_NONE     0
#define OAK_PDF_PERMISSION_PRINT    1
#define OAK_PDF_PERMISSION_COPYING  2
#define OAK_PDF_PERMISSION_MODIFY   4
#define OAK_PDF_PERMISSION_ALL      7



//Interface definitions.
//==============================================================================================================
typedef long	(__stdcall *poakBegin)();
typedef void	(__stdcall *poakEnd)(long id);
typedef long	(__stdcall *poakExport)(long id);
typedef long	(__stdcall *poakSetOption)(long id,long code,long nPara1,long nPara2,char *pPara1,char *pPara2);
typedef long	(__stdcall *poakGetOption)(long id,long code,long nPara1,long nPara2,char *pPara1,char *pPara2);



//==============================================================================================================
class CDemo_vcDlg : public CDialog
{
private:
	HMODULE				hmodule;
	poakBegin			oakBegin;
	poakEnd				oakEnd;
	poakExport			oakExport;
	poakSetOption		oakSetOption;
	poakGetOption		oakGetOption;

	BOOL Load();
	void Free();

// Construction
public:
	CDemo_vcDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CDemo_vcDlg)
	enum { IDD = IDD_DEMO_VC_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDemo_vcDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CDemo_vcDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonDemo();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DEMO_VCDLG_H__B3EC57B5_DD17_41B3_BB1F_E1493109F05D__INCLUDED_)
